from flask import Flask
from flask_pymongo import PyMongo

from config.gitUtils import GitUtils

app = Flask(__name__)
app.config["MONGO_URI"] = "mongodb://localhost:27017/squelette"
mongo = PyMongo(app)


class Utils:
    ## Fonction permettant de changer la version
    def changer_version(self, idContenu, version, nomBranche=""):
        from modele.contenu_dao import ContenuDao
        # on recupere le chemin du fichier associé au contenu (dans les 2 cas)
        chemin = ContenuDao().get_chemin_du_contenu(idContenu)
        repertoire = chemin[:chemin.rfind("/") + 1]

        if version != 0:
            # on change le repertoire récupéré ci dessus dans la bonne version (si on travaille avec une version)
            idCommit = ContenuDao().get_commit_pour_une_version(idContenu, version)
            GitUtils().changerVersionCommit(repertoire, idCommit)
        else:
            GitUtils().changerVersionBranche(repertoire, nomBranche)

    def recuperer_contenu_fichier(self, id_contenu, en_cours=False):
        from modele.contenu_dao import ContenuDao
        from modele.encours_dao import EncoursDao

        if(en_cours):
            chemin = EncoursDao().get_chemin_contenu_en_cours(id_contenu)
        else:

            chemin = ContenuDao().get_chemin_du_contenu(id_contenu)
        with open(chemin, "r") as fichier:
            texte = fichier.read()

        return texte.strip()

    ## Fonction qui permet de mettre à jour l'intérieur du texte d'un contenu
    def changer_texte_fichier(self, id_contenu, nouveau_texte):
        from modele.contenu_dao import ContenuDao
        from modele.encours_dao import EncoursDao
        chemin_fichier = EncoursDao().get_chemin_contenu_en_cours(id_contenu)
        print("chemin_fichier " + chemin_fichier)
        myFile = open(chemin_fichier, "w")
        # y ajouter le texte du contenu
        myFile.write(nouveau_texte)
        myFile.close()
